<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="账户ID" prop="accountId">
        <el-input
          v-model="queryParams.accountId"
          placeholder="请输入账户ID"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="账户名称" prop="accountName">
        <el-input
          v-model="queryParams.accountName"
          placeholder="请输入账户名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['baidu:BdAccount:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['baidu:BdAccount:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['baidu:BdAccount:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          :loading="exportLoading"
          @click="handleExport"
          v-hasPermi="['baidu:BdAccount:export']"
        >导出</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          size="mini"
          @click="auth"
          v-hasPermi="['baidu:BdAccount:list']"
        >授权链接</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          size="mini"
          :disabled="loading2"
          @click="sync"
          v-loading="loading2"
          v-hasPermi="['baidu:BdAccount:list']"
        >同步账户数据</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table border v-loading="loading" :data="BdAccountList">
<!--      <el-table-column label="账户ID" align="center" prop="accountId" />-->
      <el-table-column label="账户名称" align="center" prop="accountName" />
      <el-table-column label="所属用户" align="center" prop="userName" />
      <el-table-column label="token" align="center" prop="token" />
      <el-table-column label="计划数量" align="center" prop="planCount" />
      <el-table-column label="单元数量" align="center" prop="unitCount" />
      <el-table-column label="创意数量" align="center" prop="creativeCount" />
      <el-table-column label="备注" align="center" prop="remark" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['baidu:BdAccount:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            v-if="!scope.row.loading"
            @click="syncAccount(scope.row)"
            v-hasPermi="['baidu:BdAccount:list']"
          >同步账户数据</el-button>
          <el-button
            size="mini"
            type="text"
            disabled
            v-if="scope.row.loading"
          >正在同步数据</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['baidu:BdAccount:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改百度账号对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="账户名称" prop="accountName">
          <el-input v-model="form.accountName" placeholder="请输入账户名称" />
        </el-form-item>
        <el-form-item label="token" prop="token">
          <el-input v-model="form.token" placeholder="请输入token" />
        </el-form-item>
        <el-form-item label="选择部门" prop="userId">
          <treeselect :clearable="false" v-model="dept.deptId" :options="deptOptions" :show-count="true" placeholder="请选择归属部门"/>
        </el-form-item>
        <el-form-item label="选择用户" prop="userId">
          <el-select v-model="dept.userId"  placeholder="请选择员工">
            <el-option
              v-for="item in users"
              :key="item.userId"
              :label="item.nickName"
              :value="item.userId">
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input type="textarea" v-model="form.remark" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>

    <!-- 添加或修改百度账号对话框 -->
    <el-dialog title="授权链接" :visible.sync="authOpen" width="500px" append-to-body>
      <a class="a" :href="url" target="_blank">{{url}}</a>
      <el-tooltip class="item" effect="dark" content="复制链接" placement="top">
        <i style="margin-left: 10px;cursor: pointer;color: #1890ff" class="el-icon-copy-document" @click="copyUrl"></i>
      </el-tooltip>
    </el-dialog>
  </div>
</template>

<script>
import { listBdAccount, getBdAccount, delBdAccount, addBdAccount, updateBdAccount, exportBdAccount, authorizationUrl, syncAccount } from "@/api/baidu/BdAccount";
import Treeselect from "@riophae/vue-treeselect";
import {treeselect} from "@/api/company/companyDept";
import {getUserListByDeptId} from "@/api/company/companyUser";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";

export default {
  name: "BdAccount",
  components: {Treeselect},
  watch: {
// 监听deptId
    'dept.deptId': 'currDeptChange'
  },
  data() {
    return {
      deptOptions: [],
      // 遮罩层
      deptId: null,
      loading: true,
      loading2: false,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 百度账号表格数据
      BdAccountList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        accountId: null,
        accountName: null,
        userId: null,
      },
      users: [],
      // 表单参数
      form: {},
      authOpen: false,
      url: {},
      dept: {
        deptId: null,
        userId: null,
      },
      // 表单校验
      rules: {
        accountName:[
          { required: true, message: "账户名称不能为空", trigger: "blur" }
        ],
        token:[
          { required: true, message: "账号token不能为空", trigger: "blur" }
        ],
      }
    };
  },
  created() {
    this.getList();
    this.getTreeselect();
  },
  methods: {
    syncAccount(row){
      row.loading = true;
      syncAccount(row.id).then(res => {
        row.loading = false;
      });
    },
    sync(){
      this.loading2 = true;
      syncAccount().then(res => {
        this.loading2 = false;
        this.getList()
      });
    },
    copyUrl(){
      navigator.clipboard.writeText(this.url)
        .then(() => {
          this.msgSuccess("复制成功");
        }).catch(err => {
          this.msgError("复制失败");
        });
    },
    auth(){
      authorizationUrl().then(res => {
        this.authOpen = true;
        this.url = res.url;
      })
    },
    currDeptChange(val) {
      this.dept.deptId = val;
      this.getUserListByDeptId();
    },
    /** 查询部门下拉树结构 */
    getTreeselect() {
      treeselect().then((response) => {
        this.deptOptions = response.data;
        if (response.data != null && response.data.length > 0) {
          this.dept.deptId = response.data[0].id;
        }
      });
    },
    /** 查询百度账号列表 */
    getList() {
      this.loading = true;
      listBdAccount(this.queryParams).then(response => {
        response.rows.forEach(row => {
          row.loading = row.loading == 1;
        })
        this.BdAccountList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.dept = {
        deptId: null,
        userId: null,
      }
      this.form = {
        id: null,
        accountId: null,
        deptId: null,
        userId: null,
        createTime: null,
        createBy: null,
        updateBy: null,
        updateTime: null,
        remark: null
      };
      this.resetForm("form");
    },
    getUserListByDeptId() {
      this.dept.userId = undefined;
      var data = {deptId: this.dept.deptId};
      getUserListByDeptId(data).then(response => {
        this.users = response.data;
      });
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加百度账号";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getBdAccount(id).then(response => {
        this.form = response.data;
        this.currDeptChange(this.form.deptId);
        this.dept.userId = response.data.userId;
        this.open = true;
        this.title = "修改百度账号";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          this.form = {
            ...this.form,...this.dept
          }
          if (this.form.id != null) {
            updateBdAccount(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addBdAccount(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除百度账号编号为"' + ids + '"的数据项?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function () {
        return delBdAccount(ids);
      }).then(() => {
        this.getList();
        this.msgSuccess("删除成功");
      }).catch(() => {
      });
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有百度账号数据项?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(() => {
        this.exportLoading = true;
        return exportBdAccount(queryParams);
      }).then(response => {
        this.download(response.msg);
        this.exportLoading = false;
      }).catch(() => {
      });
    }
  }
};
</script>
<style>
.a{
  text-decoration: underline;
}
.a:hover{
  text-decoration: underline;
}
</style>
